<?php

class Date{

public $table;
public $id;
public $eventId;
public $start;
public $end;
public $error = array();

function __construct(){
	global $wpdb;
	$this->table = $wpdb->prefix."eom_dates";
}

//add data to $this, via array(start, startTime, end, endTime)  - no end date in past error if admin
public function put($data, $isAdmin=NULL){
	$start = (int) strtotime($data['start'].' '.$data['startTime']);
	$end = (int) strtotime($data['end'].' '.$data['endTime']);
	$this->eventId = (int) $data['eventId'];
	if($start>=$end){$this->error[] = 'Starting date cannot occur after ending date.';return false;}
	if( ($isAdmin==NULL) && ($end<time())){$this->error[] = 'Ending date cannot occur in the past.';return false;}
	if( ($start+432000) < $end ){$this->error[] = 'Events can not occur for longer than 5 days.';return false;}
	//YYYY-MM-DD HH:MM:SS - format for datetime	
	$this->start = date('Y-m-d G:i:s', $start);
	$this->end = date('Y-m-d G:i:s', $end);
	return true;
}

//add to database
public function save(){
	global $wpdb;
	$id=$wpdb->get_var($wpdb->prepare("SELECT id FROM ".$this->table." WHERE event_id = %d", $this->eventId));
	if($id){ //update
		$data=array('start'=>$this->start,'end'=>$this->end);
		$type=array('%s','%s');
		$wpdb->update( $this->table, $data, array('id'=>$id), $datatype, '%d');
	}else{ //insert
		$data=array('start'=>$this->start,'end'=>$this->end,'event_id'=>$this->eventId);
		$type=array('%s','%s','%d');
		if($wpdb->insert($this->table, $data, $type)){return true;}
	}
	return false;
}

//return by $eventId, false on failure
public function get($eventId){
	global $wpdb;
	$sql=$wpdb->prepare("SELECT * FROM ".$this->table." WHERE event_id = %s", $eventId);
	$return=$wpdb->get_row($sql, ARRAY_A);
	if($this->debug){print_r(__CLASS__.' -> '.__FUNCTION__.' at '.__LINE__.'<pre>'.$wpdb->last_query.'</pre>');}
	if($return){
		$this->id = $return['id'];
		$this->start = $return['start'];
		$this->end = $return['end'];
	}else{return false;}
}

}//END Date
?>